﻿@page "/outbound/addlist"

@inject HttpClient WebClient
@inject IJSRuntime JSRuntime
@inject ISnackbar Snackbar
@inject IDialogService DialogService
@inject NavigationManager NavigationManager

@using SwP.Fulfillment.ParcelLogger.Shared

<MudForm @ref="_form" @bind-IsValid="@success" @bind-Errors="@errors">
    <MudStack>
        <MudContainer Class="d-flex justify-center align-center" MaxWidth="MaxWidth.Medium">

            <MudTextField @bind-Value="_batchName" 
                          Label="Name" 
                          Variant="Variant.Outlined"
                          Validation="@(new Func<string, Task<string>>(ListName))"
                          Required
                          RequiredError="Please enter unique name"/>
        </MudContainer>
        <MudContainer Class="d-flex justify-center align-center" MaxWidth="MaxWidth.Small">
            <MudTextField @bind-Value="_pastedTrackingIds" 
                          Label="TrackingIds" 
                          Variant="Variant.Outlined"
                          Validation="@(new Func<string, Task<string>>(ListRecords))"
                          Required
                          RequiredError="Please enter items"
                          Lines="10" />
        
         </MudContainer>
        <MudContainer Class="d-flex justify-center align-center" MaxWidth="MaxWidth.Medium">
            @if(!_form.IsValid)
            {
                <MudFab Color="Color.Primary" StartIcon="@Icons.Material.Filled.Check" Size="Size.Large" OnClick="@(() => _form.Validate())"></MudFab>
            }
            else
            {
                <MudFab Color="Color.Success" StartIcon="@Icons.Material.Filled.Save" Size="Size.Large" OnClick="Add"></MudFab>
            }
        </MudContainer>
     </MudStack>
</MudForm>

@code
{
    bool success;
    string[] errors = { };
    MudForm _form;
    string _pastedTrackingIds = string.Empty;
    string _batchName = string.Empty;



    async Task<string> ListName(string arg)
    {
        if (string.IsNullOrWhiteSpace(_batchName))
        {
            // _canSave = false;
            var errorMsg = "Name is empty";
            Snackbar.Clear();
            Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
            Snackbar.Add(errorMsg, Severity.Error);
            return errorMsg;
        }
        if (_batchName.Length > 50)
        {
            // _canSave = false;
            var errorMsg = "Maximum lenght for name is 50";
            Snackbar.Clear();
            Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
            Snackbar.Add(errorMsg, Severity.Error);
            return errorMsg;
        }
        try
        {
            //check if batch with same name exists
            //var list = await WebClient.GetFromJsonAsync<List<RecordsList>>("api/outbounds");
            var response = await WebClient.GetAsync("api/outbounds");
            response.EnsureSuccessStatusCode(); // Ensure a successful response
            try
            {
                var list = await response.Content.ReadFromJsonAsync<List<RecordsList>>();
                if (list.Any(b => !b.Locked && b.Description == _batchName))
                {
                    //   _canSave = false;
                    var errorMsg = "Name already exists";
                    Snackbar.Clear();
                    Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
                    Snackbar.Add(errorMsg, Severity.Error);
                    return errorMsg;
                }
            }
            catch
            {

            }



        }
        catch (Exception e)
        {
            // _canSave = false;
            var errorMsg = "Failed to verify record. Please check connection and try again.";
            Snackbar.Clear();
            Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
            Snackbar.Add(errorMsg, Severity.Error);
            return errorMsg;

        }
        return string.Empty;
    }
    async Task<string> ListRecords(string arg)
    {
        var lineSeparator = new[] { Environment.NewLine };
        var itemSeparators = new[] { ",", ";", "\t" };

        try
        {
            var lines = _pastedTrackingIds.Split(lineSeparator, StringSplitOptions.RemoveEmptyEntries);

            if (lines.Length < 1)
            {
                return ShowSnackbarError("No records could be parsed");
            }

            var valsList = new List<string>();

            for (int i = 0; i < lines.Length; i++)
            {
                var line = lines[i];
                var vals = line.Split(itemSeparators, StringSplitOptions.RemoveEmptyEntries);

                if (vals.Length < 1)
                {
                    return ShowSnackbarError($"No barcodes could be parsed at line {i}");
                }

                if (vals.Length > 3)
                {
                    return ShowSnackbarError($"Maximum of 3 barcodes per package. Too many at line {i}");
                }

                if (vals.Any(x => x.Length < 5 || x.Length > 50))
                {
                    return ShowSnackbarError($"Length of each barcode must be between 5 and 50. Error at line {i}");
                }
                foreach(var val in vals)
                {
                    if(valsList.Any(x => x.ToLower() == val.ToLower()))
                    {
                        return ShowSnackbarError($"Barcode '{val}' already exists in another item");
                    }
                }
                valsList.AddRange(vals.ToList());
            }

        }
        catch (HttpRequestException ex)
        {
            return ShowSnackbarError("Failed to parse entered values. Please try again.");
        }
        return string.Empty;


    }

    string ShowSnackbarError(string message)
    {
        Snackbar.Clear();
        Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
        Snackbar.Add(message, Severity.Error);
        return message;
    }

    async Task Add()
    {
        try
        {
            var lineSeparator = new[] { Environment.NewLine };
            var itemSeparators = new[] { ",", ";", "\t" };
            var lines = _pastedTrackingIds.Split(lineSeparator, StringSplitOptions.RemoveEmptyEntries);

            var b = new RecordsList();
            b.Description = _batchName;
            b.Records = new List<Record>();
            b.DateCreated = DateTime.Now;
            for (int i = 0; i < lines.Length; i++)
            {
                var line = lines[i];
                var vals = line.Split(itemSeparators, StringSplitOptions.RemoveEmptyEntries);
                var rec = new Record();
                rec.DateCreated = DateTime.Now;
                //rec.Outbound = b;
                //rec.OutboundID = createdBatch.ListID;
                rec.Barcode = vals[0];
                if (vals.Length > 1)
                    rec.Barcode2 = vals[1];
                if (vals.Length > 2)
                    rec.Barcode3 = vals[2];

                b.Records.Add(rec);
            }
            //
            //var json = System.Text.Json.JsonSerializer.Serialize<RecordsList> (b);
            //
            var response = await WebClient.PostAsJsonAsync("api/outbounds", b);
            if (response.IsSuccessStatusCode)
            {                

                var parameters = new DialogParameters<Dialog_AddAnotherOrClose>();
                parameters.Add(x => x.Content, "List saved");
                var dialog = await DialogService.ShowAsync<Dialog_AddAnotherOrClose>("Return to previous screen?", new DialogOptions() { Position = DialogPosition.TopCenter });
                var result = await dialog.Result;
                if (!result.Canceled)
                {
                    //NavigationManager.NavigateTo($"./scan/{createdBatch.BatchID}", true);
                    NavigationManager.NavigateTo($"./outbound/", true);

                }
                await _form.ResetAsync();
            }
            else
            {
                var errorMsg = "Failed save list. Please check connection and try again.";
                Snackbar.Clear();
                Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
                Snackbar.Add(errorMsg, Severity.Error);
                return;

            }
        }
        catch (HttpRequestException ex)
        {
            var errorMsg = "Failed to create record. Please try again.";
            Snackbar.Clear();
            Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
            Snackbar.Add(errorMsg, Severity.Error);
        }
    }

    // async Task Add()
    // {
    //     try
    //     {
    //         var lineSeparator = new[] { Environment.NewLine };
    //         var itemSeparators = new[] { ",", ";", "\t" };
    //         var lines = _pastedTrackingIds.Split(lineSeparator, StringSplitOptions.RemoveEmptyEntries);

    //         var b = new RecordsList();
    //         b.Description = _batchName;
    //         //b.Records = new List<Record>();


    //         var response = await WebClient.PostAsJsonAsync("api/outbounds", b);
    //         if(response.IsSuccessStatusCode)
    //         {
    //             var createdBatch = await response.Content.ReadFromJsonAsync<RecordsList>();
    //             for (int i = 0; i < lines.Length; i++)
    //             {
    //                 var line = lines[i];
    //                 var vals = line.Split(itemSeparators, StringSplitOptions.RemoveEmptyEntries);
    //                 var rec = new Record();
    //                 rec.OutboundID = createdBatch.ListID;                    
    //                 rec.Barcode = vals[0];
    //                 if (vals.Length > 1)
    //                     rec.Barcode2 = vals[1];
    //                 if (vals.Length > 2)
    //                     rec.Barcode3 = vals[2];

    //                 response = await WebClient.PostAsJsonAsync("api/records", rec);
    //             }  
    //             var parameters = new DialogParameters<Dialog_AddAnotherOrClose>();
    //             parameters.Add(x => x.Content, "List saved");
    //             var dialog = await DialogService.ShowAsync<Dialog_AddAnotherOrClose>("", new DialogOptions() { Position = DialogPosition.TopCenter });
    //             var result = await dialog.Result;
    //             if (!result.Cancelled)
    //             {
    //                 //NavigationManager.NavigateTo($"./scan/{createdBatch.BatchID}", true);
    //                 NavigationManager.NavigateTo($"./outbound/", true);

    //             }
    //             await _form.ResetAsync();
    //         }
    //         else
    //         {
    //             var errorMsg = "Failed save list. Please check connection and try again.";
    //             Snackbar.Clear();
    //             Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
    //             Snackbar.Add(errorMsg, Severity.Error);
    //             return;

    //         }
          


    //     }
    //     catch (HttpRequestException ex)
    //     {
    //         var errorMsg = "Failed to create record. Please try again.";
    //         Snackbar.Clear();
    //         Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
    //         Snackbar.Add(errorMsg, Severity.Error);
    //     }
    // }
    
}